<template>
  <DeviceEditorPage
      :mode="DeviceEditorMode.ADD_NEW"
      :cancel-button="hasOtherDevices ? CancelButton.BACK : CancelButton.SIGN_OUT"
      :online="deviceStatus.online"
      :step="step"
      :error="error"
      :in-progress="inProgress"
      @input="onInput"
      @cancel="onCancel"
      @save="onSave"
      @done="onDone"
  />
</template>

<script>
  import { createNamespacedHelpers } from 'vuex'

  import DeviceEditorPage from '@/pages/device-editor/component/DeviceEditorPage'
  import { CancelButton, DeviceEditorMode, DeviceEditorStep } from '@/pages/device-editor/component/consts'

  const { mapState } = createNamespacedHelpers('addDevice')

  export default {
    name: 'AddDevicePage',
    components: { DeviceEditorPage },
    data: () => ({
      step: DeviceEditorStep.EDIT_DEVICE,
      CancelButton: CancelButton,
      DeviceEditorMode: DeviceEditorMode
    }),
    computed: {
      ...mapState([ 'hasOtherDevices', 'deviceStatus', 'inProgress', 'error' ])
    },
    methods: {
      onInput() {
        if (this.error) {
          this.$store.commit('addDevice/resetError')
        }
      },
      onCancel() {
        this.onInput()
        this.step = DeviceEditorStep.EDIT_DEVICE
      },
      onSave(device) {
        this.onInput()
        this.$store.dispatch('addDevice/loadStatus', {
          device: device,
          onSuccess: (() => {
            this.step = DeviceEditorStep.CHOOSE_NAME
          }).bind(this)
        })
      },
      onDone(deviceValue) {
        this.onInput()
        this.$store.dispatch('addDevice/addDevice', {
          device: deviceValue,
          online: this.deviceStatus.online,
          onSuccess: (() => {
            this.$router.push('chooseDevice')
          }).bind(this)
        })
      }
    }
  }
</script>